unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, EZMapProjection, ComCtrls, ExtCtrls,

  //Add manually
  EZMapProjectionError;

type
  TForm1 = class(TForm)
    EZMapProjection1: TEZMapProjection;
    Button1: TButton;
    ComboBox1: TComboBox;
    Button2: TButton;
    DateTimePicker1: TDateTimePicker;
    Button3: TButton;
    Button5: TButton;
    Button4: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button6: TButton;
    Label5: TLabel;
    Bevel1: TBevel;
    Image1: TImage;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label6: TLabel;
    Button7: TButton;
    Label7: TLabel;
    Image2: TImage;
    Button8: TButton;
    Label8: TLabel;
    Label9: TLabel;
    Button9: TButton;
    Label10: TLabel;
    Label11: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure ErrorCap(Val:Integer;Text:string);
    procedure SetOrthoDemo;
  public
    Transformed : Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
//------------------------------------------------------------------------------
procedure TForm1.FormShow(Sender: TObject);
begin
  LoadErrorList('Error.dat');
end;
//------------------------------------------------------------------------------
procedure TForm1.SetOrthoDemo;
var
 MapRef : TMapReference;
begin
  EZMapProjection1.GetMapReference(MapRef);
  MapRef.Calculated := True;
  MapRef.Values.Rad := 912;
  MapRef.Values.Th0 := 5;
  MapRef.Values.Ph0 := 52;
  MapRef.Values.X0  := 117.5;
  MapRef.Values.Y0  := 123;
  MapRef.Zone       := 'U31';
  EZMapProjection1.SetMapReference(MapRef);
  Image1.Visible := True;
end;
//------------------------------------------------------------------------------
procedure TForm1.ErrorCap(Val:Integer;Text:string);
var
  S : string;
begin
  if (Val = 0) then Label4.Caption := Text+'  Error: '+IntToStr(Val)
  else Label4.Caption := GetErrorCode(Val).Error+'  Error: '+IntToStr(Val);
end;
//------------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
  //------
  function GetPortion(ReturnValue,Portion:byte):Boolean;
  begin
   if (ReturnValue shr Portion) and $01 = 1 then Result := False else Result := True;
  end;
  //------
var
  MapRef : TMapReference;
  B : Byte;
begin

  B := EZMapProjection1.LoadDll('User ID','Key');
  if GetPortion(B,$00) then Caption := 'EZProjection Dll: Unlocked' else Caption := 'EZProjection Dll: DEMO VERSION';
  if not GetPortion(B,$00) then Label4.Caption := 'Only Orthographic and WGS84 conversions possible';
  if not GetPortion(B,$01) then Label4.Caption := 'EZProjection Dll not found';
  if not GetPortion(B,$02) then Label4.Caption := 'Dll(''s) have already been loaded';

  ComboBox1.ItemIndex := EZMapProjection1.GetProjectionList(ComboBox1.Items);
  EZMapProjection1.SetDemoValues;
  SetOrthoDemo;
  DateTimePicker1.DateTime := Now;
  Transformed := False;
end;
//------------------------------------------------------------------------------
procedure TForm1.ComboBox1Change(Sender: TObject);
var
  MapRef : TMapReference;
begin
  MapRef.Projection := EZMapProjection1.SetMapProjection(ComboBox1.ItemIndex);
  EZMapProjection1.SetDemoValues(MapRef);
  Label4.Caption := 'Map index: '+IntToStr(EZMapProjection1.GetProjectionIndex);
  if MapRef.Projection = mpOrthographic then SetOrthoDemo else Image1.Visible := False;;
end;
//------------------------------------------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
var
  D : TDeclination;
begin
  D := EZMapProjection1.GetDeclination(10,50,0,DateTimePicker1.DateTime);
  ErrorCap(D.Flag,'Declination correction: '+FormatFloat('0.0000',D.D));
end;
//------------------------------------------------------------------------------
procedure TForm1.Button3Click(Sender: TObject);
var
  C : TCoordinate;
begin
  C := EZMapProjection1.CalculateFor(0,50);
  ErrorCap(C.Flag,FormatFloat('X: 0.000',C.Horizontal)+'   '+FormatFloat('Y: 0.000',C.Vertical));
end;
//------------------------------------------------------------------------------
procedure TForm1.Button5Click(Sender: TObject);
var
  C : TCoordinate;
  S : TStringPoint;
begin
  C := EZMapProjection1.CalculateInv(110,110);
  S := EZMapProjection1.GeoToTxt(C.Horizontal,C.Vertical,hdddmmss_ss);
  ErrorCap(C.Flag,S.S1+' '+S.S2);
end;
//------------------------------------------------------------------------------
procedure TForm1.Button4Click(Sender: TObject);
var
  C : TCoordinate;
  S : TStringPoint;
begin
  C := EZMapProjection1.CalculateInv(1000,1000);
  S := EZMapProjection1.GeoToTxt(C.Horizontal,C.Vertical,hdddmmss_ss);
  ErrorCap(C.Flag,S.S1+' '+S.S2);
end;
//------------------------------------------------------------------------------
procedure TForm1.Button6Click(Sender: TObject);
var
  C : TCoordinate;
  S : TStringPoint;
begin
  C := EZMapProjection1.FromTo(155000,463000,ifNatGrid,ofGeoDatum,0,DefDatum);
  S := EZMapProjection1.GeoToTxt(C.Horizontal,C.Vertical,hdddmmss_ss);
  ErrorCap(C.Flag,S.S1+' '+S.S2);
end;
//------------------------------------------------------------------------------
procedure TForm1.Button9Click(Sender: TObject);
var
  C : TCoordinate;
  S : TStringPoint;
begin
  C := EZMapProjection1.FromTo(663225,5781015,ifUTMDatum,ofGeoDatum,61,DefDatum);
  S := EZMapProjection1.GeoToTxt(C.Horizontal,C.Vertical,hdddmmss_ss);
  ErrorCap(C.Flag,S.S1+' '+S.S2);
end;
//------------------------------------------------------------------------------
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  C : TCoordinate;
  S : TStringPoint;
begin
  Image2.Visible := False;
  C := EZMapProjection1.CalculateInv(X,Y);
  S := EZMapProjection1.GeoToTxt(C.Horizontal,C.Vertical,hdddmmss_ss);
  ErrorCap(C.Flag,S.S1+' '+S.S2);
end;
//------------------------------------------------------------------------------
procedure TForm1.Button7Click(Sender: TObject);
var
  C : TConstants;
begin
  C := EZMapProjection1.GetConstants(1,178);
  Label4.Caption := FormatFloat('Radius: 0.000',C.Radius)+', '+FormatFloat('Flat: 0.000000',C.Flattening)+', '+
                    FormatFloat('Scale: 0.000000',C.Scale)+', '+FormatFloat('dX: 0.0',C.dX)+', '+
                    FormatFloat('dY: 0.0',C.dY)+', '+FormatFloat('dZ: 0.0',C.dZ);
end;
//------------------------------------------------------------------------------
procedure TForm1.Button8Click(Sender: TObject);
var
  MapReference1,MapReference2 : TMapReference;
  X,Y : integer;
  Po : TPointOK;
begin
  if not Transformed then begin
     {Create the target image}
     Image2.Picture.Bitmap := TBitmap.Create;
     Image2.Picture.Bitmap.PixelFormat := pf24Bit;
     Image2.Picture.Bitmap.Width := Image2.Width;
     Image2.Picture.Bitmap.Height := Image2.Height;

     {Set Mapreference for the map image}
     MapReference1.Projection := mpOrthographic;
     EZMapProjection1.SetDemoValues(MapReference1);
     MapReference1.Values.Rad := 912;
     MapReference1.Values.Th0 := 5;
     MapReference1.Values.Ph0 := 52;
     MapReference1.Values.X0  := 117.5;
     MapReference1.Values.Y0  := 123;

     {Set Mapreference for the target map image}
     MapReference2.Projection := mpEquirectangular;
     EZMapProjection1.SetDemoValues(MapReference2);
     MapReference2.Values.Rad := 600;
     MapReference2.Values.X0  := 55;
     MapReference2.Values.Y0  := 680;

     {Copy every pixel from the map image corresponding to a target map pixel}
     for X := 0 to Image2.Width do for Y := 0 to Image2.Height do begin
       PO := EZMapProjection1.FromToProjectionPoint(X,Y,MapReference2,MapReference1);
       if Po.OK and (Po.X >= 0) and (Po.X < Image1.Width) and (Po.Y >= 0) and (Po.Y < Image1.Height) then
         Image2.Picture.Bitmap.Canvas.Pixels[X,Y] := Image1.Picture.Bitmap.Canvas.Pixels[Round(Po.X),Round(Po.Y)];
     end;

     Transformed := True;
  end;

   Image2.Visible := True;
end;
//------------------------------------------------------------------------------
end.
